Index: dll/shellext/shellbtrfs/recv.h
===================================================================
--- dll/shellext/shellbtrfs/recv.h	(nonexistent)
+++ dll/shellext/shellbtrfs/recv.h	(copie de travail)
@@ -0,0 +1,88 @@
+/* Copyright (c) Mark Harmstone 2017
+ *
+ * This file is part of WinBtrfs.
+ *
+ * WinBtrfs is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public Licence as published by
+ * the Free Software Foundation, either version 3 of the Licence, or
+ * (at your option) any later version.
+ *
+ * WinBtrfs is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public Licence for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public Licence
+ * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
+
+#include <shlobj.h>
+#include <string>
+#include <vector>
+#ifndef __REACTOS__
+#include "../btrfs.h"
+#else
+#include "btrfs.h"
+#endif
+
+extern LONG objs_loaded;
+
+typedef struct {
+    BTRFS_UUID uuid;
+    UINT64 transid;
+    std::wstring path;
+} subvol_cache;
+
+class BtrfsRecv {
+public:
+    BtrfsRecv() {
+        thread = NULL;
+        master = INVALID_HANDLE_VALUE;
+        dir = INVALID_HANDLE_VALUE;
+        running = FALSE;
+        cancelling = FALSE;
+        stransid = 0;
+        num_received = 0;
+        hwnd = NULL;
+        cache.clear();
+    }
+
+    virtual ~BtrfsRecv() {
+        cache.clear();
+    }
+
+    void Open(HWND hwnd, WCHAR* file, WCHAR* path, BOOL quiet);
+    DWORD recv_thread();
+    INT_PTR CALLBACK RecvProgressDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+private:
+    BOOL cmd_subvol(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_snapshot(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_mkfile(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_rename(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_link(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_unlink(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_rmdir(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_setxattr(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_removexattr(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_write(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_clone(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_truncate(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_chmod(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_chown(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    BOOL cmd_utimes(HWND hwnd, btrfs_send_command* cmd, UINT8* data);
+    void add_cache_entry(BTRFS_UUID* uuid, UINT64 transid, std::wstring path);
+    BOOL utf8_to_utf16(HWND hwnd, char* utf8, ULONG utf8len, std::wstring* utf16);
+    void ShowRecvError(int resid, ...);
+    BOOL find_tlv(UINT8* data, ULONG datalen, UINT16 type, void** value, ULONG* len);
+    BOOL do_recv(HANDLE f, UINT64* pos, UINT64 size);
+
+    HANDLE dir, parent, master, thread, lastwritefile;
+    HWND hwnd;
+    std::wstring streamfile, dirpath, subvolpath, lastwritepath;
+    DWORD lastwriteatt;
+    ULONG num_received;
+    UINT64 stransid;
+    BTRFS_UUID subvol_uuid;
+    BOOL running, cancelling;
+    std::vector<subvol_cache> cache;
+};

Modification de propriétés sur dll/shellext/shellbtrfs/recv.h
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Index: dll/shellext/shellbtrfs/resource.h
===================================================================
--- dll/shellext/shellbtrfs/resource.h	(révision 75772)
+++ dll/shellext/shellbtrfs/resource.h	(copie de travail)
@@ -8,12 +8,17 @@
 #define IDD_SIZE_DETAILS                103
 #define IDS_NEW_SUBVOL_FILENAME         104
 #define IDS_CREATE_SNAPSHOT             105
+#define IDD_VOL_PROP_SHEET              105
 #define IDS_CREATE_SNAPSHOT_HELP_TEXT   106
+#define IDD_VOL_USAGE                   106
 #define IDS_SNAPSHOT_FILENAME           107
 #define IDD_PROP_SHEET                  107
 #define IDS_PROP_SHEET_TITLE            108
+#define IDD_BALANCE_OPTIONS             108
 #define IDS_INODE_FILE                  109
+#define IDD_BALANCE                     109
 #define IDS_INODE_DIR                   110
+#define IDD_DEVICES                     110
 #define IDS_INODE_CHAR                  111
 #define IDS_INODE_BLOCK                 112
 #define IDS_INODE_FIFO                  113
@@ -21,6 +26,7 @@
 #define IDS_INODE_SYMLINK               115
 #define IDS_INODE_UNKNOWN               116
 #define IDS_SET_INODE_INFO_ERROR        117
+#define IDS_CANNOT_FIND_DEVICE          117
 #define IDS_SIZE_BYTE                   118
 #define IDS_SIZE_BYTES                  119
 #define IDS_SIZE_KB                     120
@@ -32,7 +38,164 @@
 #define IDS_VARIOUS                     126
 #define IDS_INODE_CHAR_SIMPLE           127
 #define IDS_INODE_BLOCK_SIMPLE          128
+#define IDS_VOL_PROP_SHEET_TITLE        129
 #define IDS_SIZE_LARGE                  130
+#define IDS_SINGLE                      131
+#define IDS_DUP                         132
+#define IDS_RAID0                       133
+#define IDS_RAID1                       134
+#define IDS_RAID10                      135
+#define IDS_RAID5                       136
+#define IDS_RAID6                       137
+#define IDS_USAGE_DATA                  138
+#define IDS_USAGE_MIXED                 139
+#define IDS_USAGE_METADATA              140
+#define IDS_USAGE_SYSTEM                141
+#define IDS_USAGE_UNALLOC               142
+#define IDS_UNKNOWN_DEVICE              143
+#define IDS_USAGE_DEV_SIZE              144
+#define IDS_USAGE_DEV_ALLOC             145
+#define IDS_USAGE_DEV_UNALLOC           146
+#define IDS_USAGE_DATA_RATIO            147
+#define IDS_USAGE_METADATA_RATIO        148
+#define IDS_NO_BALANCE                  149
+#define IDS_SINGLE2                     150
+#define IDS_DEVID_LIST                  151
+#define IDS_BALANCE_RUNNING             152
+#define IDS_DRANGE_END_BEFORE_START     153
+#define IDS_VRANGE_END_BEFORE_START     154
+#define IDS_LIMIT_END_BEFORE_START      155
+#define IDS_STRIPES_END_BEFORE_START    156
+#define IDS_USAGE_END_BEFORE_START      157
+#define IDS_ERROR                       158
+#define IDS_BALANCE_COMPLETE            159
+#define IDS_BALANCE_PAUSED              160
+#define IDS_BALANCE_CANCELLED           161
+#define IDS_DEVLIST_ID                  162
+#define IDS_DEVLIST_DESC                163
+#define IDS_DEVLIST_READONLY            164
+#define IDS_DEVLIST_SIZE                165
+#define IDS_DEVLIST_READONLY_YES        166
+#define IDS_DEVLIST_READONLY_NO         167
+#define IDD_DEVICE_ADD                  167
+#define IDS_DEVLIST_ALLOC               168
+#define IDD_SCRUB                       168
+#define IDS_DEVLIST_ALLOC_PC            169
+#define IDD_DEVICE_STATS                169
+#define IDS_BALANCE_RUNNING_REMOVAL     170
+#define IDD_RECV_PROGRESS               170
+#define IDS_BALANCE_PAUSED_REMOVAL      171
+#define IDD_SEND_SUBVOL                 171
+#define IDS_BALANCE_CANCELLED_REMOVAL   172
+#define IDD_RESIZE                      172
+#define IDS_BALANCE_COMPLETE_REMOVAL    173
+#define IDS_PARTITION                   174
+#define IDS_WHOLE_DISK                  175
+#define IDS_CANNOT_REMOVE_RAID          176
+#define IDS_REMOVE_DEVICE_CONFIRMATION  177
+#define IDS_CONFIRMATION_TITLE          178
+#define IDS_ADD_DEVICE_CONFIRMATION     179
+#define IDS_ADD_DEVICE_CONFIRMATION_FS  180
+#define IDS_BALANCE_FAILED              181
+#define IDS_BALANCE_FAILED_REMOVAL      182
+#define IDS_DISK_NUM                    183
+#define IDS_DISK_PART_NUM               184
+#define IDS_NO_SCRUB                    185
+#define IDS_SCRUB_RUNNING               186
+#define IDS_SCRUB_FINISHED              187
+#define IDS_SCRUB_PAUSED                188
+#define IDS_SCRUB_MSG_STARTED           189
+#define IDS_SCRUB_MSG_RECOVERABLE_DATA  190
+#define IDS_SCRUB_MSG_RECOVERABLE_METADATA 191
+#define IDS_SCRUB_MSG_UNRECOVERABLE_DATA 192
+#define IDS_SCRUB_MSG_UNRECOVERABLE_DATA_SUBVOL 193
+#define IDS_SCRUB_MSG_UNRECOVERABLE_METADATA 194
+#define IDS_SCRUB_MSG_UNRECOVERABLE_METADATA_FIRSTITEM 195
+#define IDS_SCRUB_MSG_FINISHED          196
+#define IDS_SCRUB_MSG_SUMMARY           197
+#define IDS_BALANCE_SCRUB_RUNNING       198
+#define IDS_SCRUB_BALANCE_RUNNING       199
+#define IDS_SCRUB_MSG_SUMMARY_ERRORS_RECOVERABLE 200
+#define IDS_SCRUB_MSG_SUMMARY_ERRORS_UNRECOVERABLE 201
+#define IDS_SCRUB_FAILED                202
+#define IDS_LOCK_FAILED                 203
+#define IDS_SCRUB_MSG_RECOVERABLE_PARITY 204
+#define IDS_COMPRESS_ANY                205
+#define IDS_COMPRESS_ZLIB               206
+#define IDS_COMPRESS_LZO                207
+#define IDS_STANDALONE_PROPSHEET_TITLE  208
+#define IDS_REFLINK_PASTE               209
+#define IDS_REFLINK_PASTE_HELP          210
+#define IDS_RECV_SUBVOL                 211
+#define IDS_RECV_SUBVOL_HELP            212
+#define IDS_RECV_CANT_OPEN_FILE         213
+#define IDS_RECV_READFILE_FAILED        214
+#define IDS_OUT_OF_MEMORY               215
+#define IDS_RECV_UNKNOWN_COMMAND        216
+#define IDS_RECV_CANT_OPEN_PATH         217
+#define IDS_RECV_RTLUTF8TOUNICODEN_FAILED 218
+#define IDS_RECV_CREATE_SUBVOL_FAILED   219
+#define IDS_RECV_MISSING_PARAM          220
+#define IDS_RECV_SHORT_PARAM            221
+#define IDS_RECV_MKNOD_FAILED           222
+#define IDS_RECV_SET_REPARSE_POINT_FAILED 223
+#define IDS_RECV_MOVEFILE_FAILED        224
+#define IDS_RECV_SETFILEPOINTER_FAILED  225
+#define IDS_RECV_WRITEFILE_FAILED       226
+#define IDS_RECV_CREATEHARDLINK_FAILED  227
+#define IDS_RECV_SETENDOFFILE_FAILED    228
+#define IDS_RECV_CANT_CREATE_FILE       229
+#define IDS_RECV_SETFILEINFO_FAILED     230
+#define IDS_RECV_SETINODEINFO_FAILED    231
+#define IDS_RECV_SUCCESS                232
+#define IDS_RECV_BUTTON_OK              233
+#define IDS_RECV_SETFILEATTRIBUTES_FAILED 234
+#define IDS_RECV_GETFILEATTRIBUTES_FAILED 235
+#define IDS_RECV_CSUM_ERROR             236
+#define IDS_RECV_NOT_A_SEND_STREAM      237
+#define IDS_RECV_UNSUPPORTED_VERSION    238
+#define IDS_RECV_SETEAFILE_FAILED       239
+#define IDS_RECV_RECEIVED_SUBVOL_FAILED 240
+#define IDS_RECV_SETSECURITYOBJECT_FAILED 241
+#define IDS_RECV_SETXATTR_FAILED        242
+#define IDS_RECV_CREATETHREAD_FAILED    243
+#define IDS_RECV_FILE_TRUNCATED         244
+#define IDS_RECV_RESERVE_SUBVOL_FAILED  245
+#define IDS_RECV_CANCELLED              246
+#define IDS_RECV_CANT_FIND_PARENT_SUBVOL 247
+#define IDS_RECV_FIND_SUBVOL_FAILED     248
+#define IDS_RECV_CREATE_SNAPSHOT_FAILED 249
+#define IDS_RECV_GETVOLUMEPATHNAME_FAILED 250
+#define IDS_RECV_DELETEFILE_FAILED      251
+#define IDS_RECV_REMOVEDIRECTORY_FAILED 252
+#define IDS_RECV_CANT_FIND_CLONE_SUBVOL 253
+#define IDS_RECV_GETFILESIZEEX_FAILED   254
+#define IDS_RECV_DUPLICATE_EXTENTS_FAILED 255
+#define IDS_RECV_SUCCESS_PLURAL         256
+#define IDS_SEND_SUBVOL                 257
+#define IDS_SEND_SUBVOL_HELP            258
+#define IDS_SEND_CANT_OPEN_FILE         259
+#define IDS_SEND_CANT_OPEN_DIR          260
+#define IDS_SEND_FSCTL_BTRFS_SEND_SUBVOL_FAILED 261
+#define IDS_SEND_FSCTL_BTRFS_READ_SEND_BUFFER_FAILED 262
+#define IDS_SEND_SUCCESS                263
+#define IDS_SEND_WRITEFILE_FAILED       264
+#define IDS_SEND_GET_FILE_INFO_FAILED   265
+#define IDS_SEND_NOT_READONLY           266
+#define IDS_NOT_SUBVOL                  267
+#define IDS_GET_FILE_IDS_FAILED         268
+#define IDS_SHPARSEDISPLAYNAME_FAILED   269
+#define IDS_SHGETPATHFROMIDLIST_FAILED  270
+#define IDS_SEND_PARENT_NOT_READONLY    271
+#define IDS_SEND_CANCEL                 272
+#define IDS_SEND_WRITING                273
+#define IDS_MISSING                     274
+#define IDS_RESIZE_SUCCESSFUL           275
+#define IDS_BALANCE_RUNNING_SHRINK      276
+#define IDS_BALANCE_PAUSED_SHRINK       277
+#define IDS_BALANCE_CANCELLED_SHRINK    278
+#define IDS_BALANCE_COMPLETE_SHRINK     279
+#define IDS_BALANCE_FAILED_SHRINK       280
 #define IDC_UID                         1001
 #define IDC_GID                         1002
 #define IDC_USERR                       1003
@@ -52,18 +215,118 @@
 #define IDC_SIZE_ON_DISK                1017
 #define IDC_GROUP_INFORMATION           1018
 #define IDC_SIZE_INLINE                 1019
+#define IDC_SETUID                      1019
 #define IDC_SIZE_UNCOMPRESSED           1020
+#define IDC_USAGE_BOX                   1020
+#define IDC_SETGID                      1020
 #define IDC_SIZE_ZLIB                   1021
+#define IDC_USAGE_REFRESH               1021
+#define IDC_STICKY                      1021
 #define IDC_SIZE_ZLIB2                  1022
 #define IDC_SIZE_LZO                    1022
+#define IDC_VOL_SHOW_USAGE              1022
+#define IDC_VOL_BALANCE                 1023
+#define IDC_PROFILES                    1024
+#define IDC_PROFILES_SINGLE             1025
+#define IDC_PROFILES_DUP                1026
+#define IDC_VOL_DEVICES                 1026
+#define IDC_PROFILES_RAID0              1027
+#define IDC_VOL_DEVICES2                1027
+#define IDC_VOL_SCRUB                   1027
+#define IDC_PROFILES_RAID1              1028
+#define IDC_PROFILES_RAID10             1029
+#define IDC_PROFILES_RAID5              1030
+#define IDC_PROFILES_RAID6              1031
+#define IDC_USAGE                       1032
+#define IDC_USAGE_START_SPINNER         1033
+#define IDC_USAGE_START                 1034
+#define IDC_USAGE_END_SPINNER           1035
+#define IDC_USAGE_END                   1036
+#define IDC_DEVID                       1037
+#define IDC_DEVID_COMBO                 1038
+#define IDC_DRANGE_START                1039
+#define IDC_DRANGE                      1040
+#define IDC_PROGRESS1                   1040
+#define IDC_BALANCE_PROGRESS            1040
+#define IDC_RECV_PROGRESS               1040
+#define IDC_DRANGE_END                  1041
+#define IDC_DATA                        1041
+#define IDC_LIMIT                       1042
+#define IDC_METADATA                    1042
+#define IDC_VRANGE                      1043
+#define IDC_SYSTEM                      1043
+#define IDC_LIMIT_START_SPINNER         1044
+#define IDC_BUTTON1                     1044
+#define IDC_DATA_OPTIONS                1044
+#define IDC_DEVICE_ADD                  1044
+#define IDC_RESET_STATS                 1044
+#define IDC_OPEN_ADMIN                  1044
+#define IDC_BROWSE                      1044
+#define IDC_LIMIT_START                 1045
+#define IDC_BUTTON2                     1045
+#define IDC_METADATA_OPTIONS            1045
+#define IDC_DEVICE_REFRESH              1045
+#define IDC_PARENT_BROWSE               1045
+#define IDC_VRANGE_END                  1046
+#define IDC_BUTTON3                     1046
+#define IDC_SYSTEM_OPTIONS              1046
+#define IDC_DEVICE_REMOVE               1046
+#define IDC_CLONE_ADD                   1046
+#define IDC_VRANGE_START                1047
+#define IDC_BALANCE_STATUS              1047
+#define IDC_DEVICE_SHOW_STATS           1047
+#define IDC_CLONE_REMOVE                1047
+#define IDC_LIMIT_END_SPINNER           1048
+#define IDC_START_BALANCE               1048
+#define IDC_DEVICE_RESIZE               1048
+#define IDC_LIMIT_END                   1049
+#define IDC_PAUSE_BALANCE               1049
+#define IDC_STRIPES                     1050
+#define IDC_BUTTON6                     1050
+#define IDC_CANCEL_BALANCE              1050
+#define IDC_STRIPES_START_SPINNER       1051
+#define IDC_STRIPES_START               1052
+#define IDC_DEVLIST                     1052
+#define IDC_STRIPES_END_SPINNER         1053
+#define IDC_DEVICE_TREE                 1053
+#define IDC_STRIPES_END                 1054
+#define IDC_UUID                        1054
+#define IDC_CONVERT                     1055
+#define IDC_SCRUB_INFO                  1055
+#define IDC_CONVERT_COMBO               1056
+#define IDC_START_SCRUB                 1056
+#define IDC_SOFT                        1057
+#define IDC_PAUSE_SCRUB                 1057
+#define IDC_CANCEL_SCRUB                1058
+#define IDC_SCRUB_PROGRESS              1059
+#define IDC_SCRUB_STATUS                1060
+#define IDC_COMPRESS_TYPE               1061
+#define IDC_CHECK1                      1062
+#define IDC_SUBVOL_RO                   1062
+#define IDC_INCREMENTAL                 1062
+#define IDC_DEVICE_ID                   1063
+#define IDC_WRITE_ERRS                  1064
+#define IDC_READ_ERRS                   1065
+#define IDC_RECV_MSG                    1065
+#define IDC_FLUSH_ERRS                  1066
+#define IDC_STREAM_DEST                 1066
+#define IDC_CORRUPTION_ERRS             1067
+#define IDC_SEND_STATUS                 1067
+#define IDC_GENERATION_ERRS             1068
+#define IDC_PARENT_SUBVOL               1068
+#define IDC_CLONE_LIST                  1069
+#define IDC_RESIZE_DEVICE_ID            1070
+#define IDC_RESIZE_CURSIZE              1071
+#define IDC_RESIZE_SLIDER               1072
+#define IDC_RESIZE_NEWSIZE              1073
 
 // Next default values for new objects
 // 
 #ifdef APSTUDIO_INVOKED
 #ifndef APSTUDIO_READONLY_SYMBOLS
-#define _APS_NEXT_RESOURCE_VALUE        104
+#define _APS_NEXT_RESOURCE_VALUE        173
 #define _APS_NEXT_COMMAND_VALUE         40001
-#define _APS_NEXT_CONTROL_VALUE         1020
+#define _APS_NEXT_CONTROL_VALUE         1073
 #define _APS_NEXT_SYMED_VALUE           101
 #endif
 #endif
